本方法可以实现对请求的完全控制。

代码示例：
```javascript
exports.url2response=async ({
  url,
  queryAll: {query},
  method,
  requestHeaders,
  postData,

  requestPipe,
  waitForResponse,
  getResponse,
  getAllResponseHeaders,

  addResponseHeader,
  setStatusCode,

  cacheUrlBy,
  cacheData,
  cacheClear,

  sleep,

})=>{
  // todo
}
```

---

## 参数说明：
1. ### 请求信息参数

 1. url

    请求地址

   1. queryAll

     请求地址的参数部分，{query}是?后面的参数部分

  1. method

    请求的方式

  1. requestHeaders

     请求头部的键值对

1. ### 获取请求响应结果的相关方法

  1. requestPipe

    把当前的请求信息转发到指定的域名，例如

    ```javascript
    if(url.match(/aa.com/)) return requestPipe({
        requestOrigin: "http://bb.com",
        responseOrigin: "http://cc.com",
   })
   ```
  当用户在`http://aa.com/xx.html` 页面上，发出了一个到达 `http://aa.com/a.php`的请求，实际请求会修改请求头部的Origin变成`http://bb.com`，并且转发该请求到 `http://cc.com/a.php`，获取到`cc.com`的结果之后再添加CORS的头部，确保当前页面能解析该跨域的结果。

    requestPipe也接受直接传入字符串目标的写法，如：
    ```javascript
    if(url.match(/\/api\//)) return requestPipe('http://xx.api.com')
```
  这种写法等同于：
```javascript
    if(url.match(/\/api\//)) return requestPipe({
        requestOrigin: "http://xx.api.com",
        responseOrigin: "http://xx.api.com",
    })
```
  这个功能在执行开发任务时相当好用，例如工程中需要用本地的代码调用不同的线上环境的数据，则可以通过requestPipe方法动态指定目标源，不需要去修改hosts或者修改代理服务器配置。
  requestPipe是一个异步方法，实际返回结果是一个Buffer。

  1. waitForResponse

    让请求正常发出，并且等待请求完成，即请求的响应头部和响应数据均获取完成。这是一个异步方法，需要使用await来确保方法已经执行完毕。

  1. getResponse

    获取响应的数据，返回值为Buffer

  1. getAllResponseHeaders

    获取响应的所有头部，返回值为对象

  getResponse和getAllResponseHeaders这两个方法在请求没有被响应之前获取到的值都是空的，需要通过waitForResponse或者requestPipe来得到请求的响应结果。

1. ### 设置响应头部的方法

  1. addResponseHeader

    添加响应头部，例如
   ```javascript
   addResponseHeader('Content-Type', 'text/html')
   ```
  1. setStatusCode

    设置响应状态码，例如

    ```javascript
    setStatusCode(404)
    ```

1. ### 请求缓存相关的方法
  1. cacheUrlBy 和 cacheData
  1. cacheClear

  代码例子：
  ```javascript
  cacheClear(/api/) // 清除缓存中请求地址包含api关键字的数据
  if(cacheUrlBy(/api/)) return cacheData().response // 如果请求地址包含api关键字，则首次请求被缓存，之后每次从缓存中直接返回结果
  ```


1. ### 其他方法

  1. sleep

    延迟响应，例如以下代码将对.php结尾的请求延迟响应3秒

    ```javascript
    exports.url2response=async ({url, sleep})=>{
        if(url.match(/\.php\b/)) await sleep(3)
    }
    ```



