本工具允许开发者根据请求的信息，来判断该请求是由浏览器执行默认的请求线路，还是进入开发者自定义的请求路线。

从仓库拉取下来的项目，可以看到文件结构如下：

```
README.md
bin/
core/
hooks.js.sample
manual/
package-lock.json
package.json
test-inject-tool.js
```

在项目目录中新建一个hooks.js，内容如下： *call:createhookjs:点此直接创建 hooks.js*
```javascript
exports.url2response=async ({
  url,
  waitForResponse,
  getResponse,
})=>{
  if(!url.match(/\:\/\/nodejs\.cn\/$/)) return true
  await waitForResponse()
  return Buffer.concat([
    getResponse(),
    Buffer.from('<script>alert("666")</s\x63ript>'),
  ])
}
```

然后运行以下命令：
```
node bin
```

点此打开 [http://nodejs.cn/](http://nodejs.cn/)

此时页面在加载之后会弹出一个alert窗口，内容为666，查看源码能看到在页面代码的最后被追加了一段脚本。(如果没看到请刷新源码页面）

---

由此，hooks.js的作用便是自定义请求的处理逻辑。后面的文档将对hooks.js的具体参数作说明。